#line 1 "C:/Users/Public/Documents/Mikroelektronika/Visual TFT/Projects/STEPPER click/MikroC/Stepper_click_Code/mikroC PRO for ARM/Stepper_click_events_code.c"
#line 1 "c:/users/public/documents/mikroelektronika/visual tft/projects/stepper click/mikroc/stepper_click_code/mikroc pro for arm/stepper_click_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct ProgressBar {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Transparent;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 unsigned int Background_Color;
 unsigned int Min;
 unsigned int Max;
 unsigned int Position;
 char Show_Position;
 char Show_Percentage;
 char Smooth;
 char Rounded;
 char Corner_Radius;
} TProgressBar;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int ProgressBarsCount;
 TProgressBar * const code *ProgressBars;
};

extern TScreen Screen1;
extern TButton Button1;
extern TButton Button2;
extern TButton Button3;
extern TButton Button4;
extern TProgressBar ProgressBar1;
extern TButton Button5;
extern TButton Button6;
extern TLabel Label1;
extern TLabel Label2;
extern TButton * const code Screen1_Buttons[6];
extern TLabel * const code Screen1_Labels[2];
extern TProgressBar * const code Screen1_ProgressBars[1];




void Button1OnClick();
void Button2OnClick();
void Button3OnClick();
void Button4OnClick();
void Button5OnClick();
void Button6OnClick();
void Single_Step();




extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char ProgressBar1_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawProgressBar(TProgressBar *AProgressBar);
void UpdatePBPosition(TProgressBar *AProgressBar);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/users/public/documents/mikroelektronika/visual tft/projects/stepper click/mikroc/stepper_click_code/mikroc pro for arm/stepper_click_resources.h"
const code char Tahoma11x13_Regular[];
#line 10 "C:/Users/Public/Documents/Mikroelektronika/Visual TFT/Projects/STEPPER click/MikroC/Stepper_click_Code/mikroC PRO for ARM/Stepper_click_events_code.c"
sbit DIR at ODR8_GPIOD_ODR_bit;
sbit STEP at ODR8_GPIOA_ODR_bit;
sbit MS1 at ODR5_GPIOA_ODR_bit;
sbit MS2 at ODR4_GPIOD_ODR_bit;
unsigned int cnt = 0;
const int delay = 500;


void Single_Step(){
 STEP = 0;
 Delay_us(delay);
 STEP = 1;
 Delay_us(delay);
}

void Change_Active_Step(int i)
 {
 switch( i )
{

 case 2:
 Button2.Color = CL_LIME;
 Button2.Gradient_Start_Color = CL_WHITE;
 Button2.Gradient_End_Color = CL_LIME;
 DrawButton(&Button2);

 Button3.Color = CL_SILVER;
 Button3.Gradient_Start_Color = CL_WHITE;
 Button3.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button3);

 Button4.Color = CL_SILVER;
 Button4.Gradient_Start_Color = CL_WHITE;
 Button4.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button4);

 Button6.Color = CL_SILVER;
 Button6.Gradient_Start_Color = CL_WHITE;
 Button6.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button6);
 break;

 case 3:
 Button2.Color = CL_SILVER;
 Button2.Gradient_Start_Color = CL_WHITE;
 Button2.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button2);

 Button3.Color = CL_LIME;
 Button3.Gradient_Start_Color = CL_WHITE;
 Button3.Gradient_End_Color = CL_LIME;
 DrawButton(&Button3);

 Button4.Color = CL_SILVER;
 Button4.Gradient_Start_Color = CL_WHITE;
 Button4.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button4);

 Button6.Color = CL_SILVER;
 Button6.Gradient_Start_Color = CL_WHITE;
 Button6.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button6);
 break;

 case 4:
 Button2.Color = CL_SILVER;
 Button2.Gradient_Start_Color = CL_WHITE;
 Button2.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button2);

 Button3.Color = CL_SILVER;
 Button3.Gradient_Start_Color = CL_WHITE;
 Button3.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button3);

 Button4.Color = CL_LIME;
 Button4.Gradient_Start_Color = CL_WHITE;
 Button4.Gradient_End_Color = CL_LIME;
 DrawButton(&Button4);

 Button6.Color = CL_SILVER;
 Button6.Gradient_Start_Color = CL_WHITE;
 Button6.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button6);
 break;

 case 6:
 Button2.Color = CL_SILVER;
 Button2.Gradient_Start_Color = CL_WHITE;
 Button2.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button2);

 Button3.Color = CL_SILVER;
 Button3.Gradient_Start_Color = CL_WHITE;
 Button3.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button3);

 Button4.Color = CL_SILVER;
 Button4.Gradient_Start_Color = CL_WHITE;
 Button4.Gradient_End_Color = CL_SILVER;
 DrawButton(&Button4);

 Button6.Color = CL_LIME;
 Button6.Gradient_Start_Color = CL_WHITE;
 Button6.Gradient_End_Color = CL_LIME;
 DrawButton(&Button6);
 break;
}
 }

void Button5OnClick() {
 DIR = ~DIR;
}

void Button2OnClick() {
 Change_Active_Step(2);

 MS1 = 0;
 MS2 = 0;
}

void Button4OnClick() {
 Change_Active_Step(4);

 MS1 = 1;
 MS2 = 0;
}

void Button3OnClick() {
 Change_Active_Step(3);

 MS1 = 0;
 MS2 = 1;
}

void Button6OnClick() {
 Change_Active_Step(6);

 MS1 = 1;
 MS2 = 1;
}

void Button1OnClick() {

 for (cnt = 0; cnt <= 2038; cnt++) {
 Single_Step();
 ProgressBar1.position = cnt;
 DrawProgressBar(&ProgressBar1);
 }
}
